var string_array;
var active_referenz;
var active_anlagenadresse;
var active_adresse;
var active_adresse_lat;
var active_adresse_long;
var active_lat;
var active_long;
var active_distance;

var active_f1;
var active_f2;
var active_f3;
var active_anmerkung;

var send_success = false;

function getDatabaseBK() {
    send_success = false;
    console.log("GetdatabaseBK!");
    $( "#betriebskontrollenView" ).empty();
    $( "#betriebskontrollenView" ).hide();
    $( "#betriebskontrollenDatabaseView" ).empty();
    $( "#betriebskontrollenDatabaseView" ).hide();
    $( "#loadingView" ).css('display', 'table');
    $( '#loadingStatus').text("Datenbank wird aktualisiert!");
    var bk_anlagenadressen_array = [];
    var bk_adressen_array = [];
    var bk_referenz_array = [];
    var x = 0;
    var dataString = "{\"name\":\""+config_name+"\", \"pass\":\""+config_passwort+"\"}";
    $.ajax({
        type: "POST",
        url: config_server + "/liftwerk_allinone/bk/bk_getdata_woechentlich.php",
        data: dataString,
        crossDomain: true,
        cache: false,
        timeout: 30000,
        success: function(result){
        	bk_state = 1;
            console.log(result);
            
            var searchbar = '<input class="searchtext" type="searchtext" id="Search2" onkeyup="mySearchFunction2()" placeholder="Adressen durchsuchen..." title="Adresse eingeben">';
            $( "#betriebskontrollenDatabaseView" ).append( $( searchbar ) );

            if(result == "error")
            {
                var htmlString = '<div class="deviceContainer">' +
                                                        '<p class="deviceName">FALSCHES PASSWORT</p>' +
                                                    '</div>';
                $( "#betriebskontrollenDatabaseView" ).append( $( htmlString ) );

                localStorage.setItem("bk_anlagenadressen", JSON.stringify(bk_anlagenadressen_array));
                localStorage.setItem("bk_adressen", JSON.stringify(bk_adressen_array));
                localStorage.setItem("bk_referenz", JSON.stringify(bk_referenz_array));
            }
            else
            {
                $.each(result, function(i, field) {
                    var date = strToDate(field.Datum_letzte_bk);
                    var kw = getCalendarweek(date);

                    var today = new Date();
                    var kw_now = getCalendarweek(today);

                    var Anlagenadresse;
                    var Adresse;
                    var Hausnummer = field.Nummer.split(',')[0];
                    var Typ = field.Nummer.split(',')[1]

                    if(field.Strasse.indexOf("/") !== -1)
                        Adresse = field.Strasse.split('/')[0] + "<br>" + field.Strasse.split('/')[1] + " " + Hausnummer + ", " + field.Plz + " " + field.Stadt;
                    else
                        Adresse = field.Strasse + " " + Hausnummer + ", " + field.Plz + " " + field.Stadt;

                    if(Typ !== " Personenaufzug")
                        Anlagenadresse = Adresse + "<br>-" + Typ;
                    else
                        Anlagenadresse = Adresse;

                    var htmlString;

                    if(kw == kw_now & date.getFullYear() == today.getFullYear())
                    {
                        // Betriebskontrolle schon gemacht
                        htmlString = '<div class="deviceContainer1" onclick="betriebskontrolle(\'' + field.Referenz + '\',\'' + Anlagenadresse + '\',\'' + Adresse + '\')">' +
                                                        '<p class="deviceName">' + Anlagenadresse + '</p>' +
                                                    '</div>';
                    }
                    else
                    {
                        // Betriebskontrollen noch nicht gemacht
                        htmlString = '<div class="deviceContainer" onclick="betriebskontrolle(\'' + field.Referenz + '\',\'' + Anlagenadresse + '\',\'' + Adresse + '\')">' +
                                                        '<p class="deviceName">' + Anlagenadresse + '</p>' +
                                                    '</div>';
                    }

                    bk_anlagenadressen_array[x] = Anlagenadresse;
                    bk_adressen_array[x] = Adresse;
                    bk_referenz_array[x] = field.Referenz;
                    x++;

                    $( "#betriebskontrollenDatabaseView" ).append( $( htmlString ) );
                    console.log(Anlagenadresse+" - "+field.Datum_letzte_bk);
                });

                //FÜR OFFLINE MODUS SPEICHERN
                //console.log(bk_adressen_array);
                
                localStorage.setItem("bk_anlagenadressen", JSON.stringify(bk_anlagenadressen_array));
                localStorage.setItem("bk_adressen", JSON.stringify(bk_adressen_array));
                localStorage.setItem("bk_referenz", JSON.stringify(bk_referenz_array));
            }

            $( "#loadingView" ).hide();
            $( "#betriebskontrollenDatabaseView" ).show();
            window.scrollTo(0,0);
        },
        error: function(result) {
        	bk_state = 1;
            bk_anlagenadressen_array = JSON.parse(localStorage.getItem("bk_anlagenadressen"));
            bk_adressen_array = JSON.parse(localStorage.getItem("bk_adressen"));
            bk_referenz_array = JSON.parse(localStorage.getItem("bk_referenz"));
            
            var searchbar = '<input class="searchtext" type="searchtext" id="Search2" onkeyup="mySearchFunction2()" placeholder="Adressen durchsuchen..." title="Adresse eingeben">';
            $( "#betriebskontrollenDatabaseView" ).append( $( searchbar ) );

            for(i=0;i<bk_adressen_array.length;i++){
                var htmlString = '<div class="deviceContainer" onclick="betriebskontrolle(\'' + bk_referenz_array[i] + '\',\'' + bk_anlagenadressen_array[i] + '\',\'' + bk_adressen_array[i] + '\')">' +
                                                        '<p class="deviceName">' + bk_anlagenadressen_array[i] + '</p>' +
                                                        '<p class="deviceAddress"></p>' +
                                                    '</div>';

                $( "#betriebskontrollenDatabaseView" ).append( $( htmlString ) );
            }
            $( "#loadingView" ).hide();
            $( "#betriebskontrollenDatabaseView" ).show();
            window.scrollTo(0,0);
            navigator.notification.alert('Keine Verbindung zum Server -> OFFLINE MODUS!', function() {}, '');
        }
    });
}

function mySearchFunction2() {
    var input = document.getElementById("Search2");
  var filter = input.value.toLowerCase();
  var nodes = document.getElementsByClassName('deviceContainer');
  var nodes1 = document.getElementsByClassName('deviceContainer1');

  for (i = 0; i < nodes.length; i++) {
    if (nodes[i].innerText.toLowerCase().includes(filter)) {
      nodes[i].style.display = "block";
    } else {
      nodes[i].style.display = "none";
    }
  }
  
  for (i = 0; i < nodes1.length; i++) {
    if (nodes1[i].innerText.toLowerCase().includes(filter)) {
      nodes1[i].style.display = "block";
    } else {
      nodes1[i].style.display = "none";
    }
  }
}

function betriebskontrolle(referenz, anlagenadresse, adresse) {
    bk_state = 2;
    $( "#betriebskontrollenDatabaseView" ).hide();

    var htmlString = '<p class="title" id="adresse">' + anlagenadresse + '</p>';
    active_referenz = referenz;
    active_adresse = adresse;
    active_anlagenadresse = anlagenadresse;
    $( "#betriebskontrollenView" ).append($( htmlString ));
     
    $( "#betriebskontrollenView" ).append(' <fieldset> ' +
                                          '     <div class="some-class">' +
                                          '         <label for="y"><input type="radio" id="r1" name="Frage1" class="rdo" checked="checked"/>Betriebskontrolle durchgeführt</label> <br>' +
                                          '         <label for="z"><input type="radio" id="r2" name="Frage1" class="rdo" />Betriebskontrolle nicht durchgeführt <br/>(Grund angeben)</label>' + 
                                          '     </div>' +
                                          ' </fieldset>');
                                        
    $( "#betriebskontrollenView" ).append(' <fieldset>' +
                                          '     <div class="some-class">' +
                                          '         <label for="y"><input type="radio" id="r3" name="Frage2" class="rdo" checked="checked"/>Notruf abgesetzt</label> <br>' +
                                          '         <label for="z"><input type="radio" id="r4" name="Frage2" class="rdo" />Notruf nicht abgesetzt <br/>(Grund angeben)</label>' +
                                          '     </div>' +
                                          ' </fieldset>');
    
    $( "#betriebskontrollenView" ).append(' <fieldset>' +
                                          '     <div class="some-class">' +
                                          '         <label for="y"><input type="radio" id="r5" name="Frage3" class="rdo" checked="checked"/>Anlage in Betrieb</label> <br>' +
                                          '         <label for="z"><input type="radio" id="r6" name="Frage3" class="rdo" />Anlage nicht in Betrieb <br/>(Grund angeben)</label>' +
                                          '     </div>' +
                                          ' </fieldset>');
    
    $( "#betriebskontrollenView" ).append(' <fieldset>' +
                                          '     <div class="some-class">' +
                                          '         <label for="y">Anmerkungen:</label> <br>' +
                                          '        <textarea id="textarea1" name="Text1" cols="1" rows="1" onkeyup="textAreaAdjust(this)"></textarea>' +
                                          '     </div>' +
                                          ' </fieldset>');

    htmlString = '<input type="button" class="btn" value="BK Absenden" onclick="BK_absenden()"></input>';
    $( "#betriebskontrollenView" ).append($( htmlString ));

    htmlString = '<input type="button" class="btn" value="BK Zurücksetzen" onclick="BK_zuruecksetzen()"></input>';
    $( "#betriebskontrollenView" ).append($( htmlString ));

    htmlString = '<input type="button" class="btn" value="Navigation" onclick="Navigation()"></input>';
    $( "#betriebskontrollenView" ).append($( htmlString ));

    $( "#betriebskontrollenView" ).show();
    window.scrollTo(0,0);
}

function BK_zuruecksetzen() {
    var dataString = "{\"betriebskontrolle\":{\"referenz\":\""+active_referenz+"\"}, \"name\":\""+config_name+"\", \"pass\":\""+config_passwort+"\"}";

    $.ajax({
        type: "POST",
        url: config_server + "/liftwerk_allinone/bk/bk_resetdata.php",
        data: dataString,
        crossDomain: true,
        cache: false,
        timeout: 30000,
        success: function(data){
            console.log("DATA: " + data);
            if(data.indexOf("success") !== -1) {
                navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nDie BK wurde zurückgesetzt!', function() {}, '');
                $( "#betriebskontrollenView" ).empty();
                $( "#betriebskontrollenView" ).hide();
                $( "#loadingView" ).hide();
                getDatabaseBK();
            }
            else if(data.indexOf("error") !== -1) {
                navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nDie BK konnte nicht zurückgesetzt werden! Bitte nochmal machen!', function() {}, '');
                $( "#loadingView" ).hide();
                $( "#betriebskontrollenView" ).show();
            } 
        },
        error: function(xhr, status, error) {
            navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nDie BK konnte nicht zurückgesetzt werden! Bitte nochmal machen!', function() {}, '');
            $( "#loadingView" ).hide();
            $( "#betriebskontrollenView" ).show();
        }
    });
}

function BK_absenden() {
    console.log('Sende wöchentliche Betriebskontrolle');
    var txtarea = $('#textarea1').val().replace(/ /g,"");

    if ((document.getElementById('r2').checked | document.getElementById('r4').checked | document.getElementById('r6').checked) & txtarea == "")
        navigator.notification.alert('Grund angeben!', function() {}, '');
    else
        BK_sendData();
}

var email_to;
var email_cc;
var email_subject;
var email_body;

function BK_sendData()  {
    function onGeolocationSuccess(location) {
        console.log('Get Current Position - Success');

        active_lat = location.coords.latitude;
        active_long = location.coords.longitude;

        var txtarea_nospace = $('#textarea1').val().replace(/ /g,"");
        if (document.getElementById('r2').checked | document.getElementById('r4').checked | document.getElementById('r6').checked | txtarea_nospace != "")
            GetGeoCoordinatesOfBkAddress(location);
        else
            SendBkAndGpsToSql(location);
    };

    function onGeolocationError(errorCode) {
        console.log('Get Current Position - Error ' + errorCode.code);
        switch (errorCode.code) {
            case 0:
            navigator.notification.alert('Fehler - Es konnte kein Standort ermittelt werden!', function() {}, '');
            break;
            case 1:
            navigator.notification.alert('Fehler - Standortinformationen müssen in den Einstellungen aktiviert sein!', function() {}, '');
            break;
            case 2:
            navigator.notification.alert('Fehler - Verbindungsabbruch!', function() {}, '');
            break;
            case 3:
            navigator.notification.alert('Fehler - Zeitüberschreitung!', function() {}, '');
            break;
        }
        //alert('code: '    + error.code    + '\n' + 'message: ' + error.message + '\n');

        $( "#loadingView" ).hide();
        $( "#betriebskontrollenView" ).show();
    };

    $( "#betriebskontrollenView" ).hide();
    $( "#loadingView" ).css('display', 'table');
    $( '#loadingStatus').text("Standort wird ermittelt!");

    navigator.geolocation.getCurrentPosition(onGeolocationSuccess, onGeolocationError, {maximumAge:60000, timeout:20000});
    //bgGeo.getCurrentPosition(onSuccess, onError);

    console.log('Get Current Position');
}

function GetGeoCoordinatesOfBkAddress(location) {
    console.log('Get Coordinates of Adress');
    active_distance = "N/A";
    var address = active_adresse.replace(/ß/g, "ss").replace("/", " ");
    
    if(address.indexOf("<br>") !== -1)
        address = address.split('<br>')[1];
    console.log(address);

                console.log('Got Coordinates of Adress');
                $( '#loadingStatus').text("Email senden");
               
                //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                //EMAIL ERSTELLEN
                //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                //email_to = 'office@liftwerk.at';
                //email_to = 'hoermann@liftwerk.at';
                //email_cc = '';
                email_subject = 'Betriebskontrolle Liftwerk - ' + active_anlagenadresse.replace("<br>", " / ");

                var txtarea = $('#textarea1').val().replace(/ /g,"");

                var today = new Date();

                var dd = today.getDate();
                var mm = today.getMonth()+1;//January is 0, so always add + 1

                var yyyy = today.getFullYear();
                if(dd<10){dd='0'+dd}
                if(mm<10){mm='0'+mm}

                var hour = today.getHours();
                if(hour<10){hour='0'+hour}
                var min = today.getMinutes();
                if(min<10){min='0'+min}
                var sec = today.getSeconds();
                if(sec<10){sec='0'+sec}

                var time = dd+'.'+mm+'.'+yyyy+' '+hour+':'+min+':'+sec;
				
                email_body = "Betriebskontrolle Wöchentlich\\n\\n" + active_anlagenadresse.replace("<br>", " / ") + "\\n" + time + "\\n\\n" + 
                			 "Aktuelle Position des Kontrolleurs: " + "https://www.google.at/maps/search/" + address.replace("/", "%2F").replace(/ /g,"+").replace(/ß/g, "ss")+ "/\\n\\n";

                if (document.getElementById('r1').checked)
                    email_body += "+ Die Betriebskontrolle wurde erfolgreich durchgeführt!\\n";
                else
                    email_body += "- Die Betriebskontrolle konnte nicht durchgeführt werden!\\n";
                
                if (document.getElementById('r3').checked)
                    email_body += "+ Der Notruf wurde erfolgreich abgesetzt!\\n";
                else
                    email_body += "- Der Notruf konnte nicht abgesetzt werden!\\n";

                if (document.getElementById('r5').checked)
                    email_body += "+ Die Anlage ist in Betrieb!\\n";
                else
                    email_body += "- Die Anlage ist außer Betrieb!\\n";
                
                email_body += "\\nKontrolleur: " + config_name + "\\n";
                
                var txtarea_nospace = $('#textarea1').val().replace(/ /g,"");
                if (txtarea_nospace != "")
                    email_body += "\\nAnmerkung des Kontrolleurs:\\n" + $('#textarea1').val();
                    
                console.log('Create Background Email');
				SendMail1(email_subject, email_body, location);
}

function SendMail1(email_subject, email_body, location) {
    console.log('Mail übermitteln');
    
    var dataString = "{\"mail\":{\"email_subject\":\""+email_subject+"\",\"email_body\":\""+email_body+"\"}, \"name\":\""+config_name+"\", \"pass\":\""+config_passwort+"\"}";

    $.ajax({
        type: "POST",
        url: config_server + "/liftwerk_allinone/mail/mail_senddata.php",
        data: dataString,
        crossDomain: true,
        cache: false,
        timeout: 30000, 
        //beforeSend: function(){ $("#update").val('Connecting...');},
        success: function(data){
            console.log("DATA: " + data);
            if(data.indexOf("success") !== -1) {
                SendBkAndGpsToSql(location);
            }
            else if(data.indexOf("error") !== -1) {
                navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nDie BK konnte nicht abgeschlossen werden! Bitte nochmal absenden!', function() {}, '');
                $( "#loadingView" ).hide();
                $( "#betriebskontrollenView" ).show();
            }
        },
        error: function(xhr, status, error) {
            navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nDie BK konnte nicht abgeschlossen werden! Bitte nochmal absenden!', function() {}, '');
            $( "#loadingView" ).hide();
            $( "#betriebskontrollenView" ).show();
        }
    });
}

function SendBkAndGpsToSql(location) {
    console.log('BK und GPS übermitteln');
    var coords = location.coords;
    var lat    = coords.latitude;
    var lng    = coords.longitude;

    //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    //SQL SERVER UPDATEN (Zeitstempel von BK + BK eintrag + GPS eintrag)!
    //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth()+1;//January is 0, so always add + 1
    var yyyy = today.getFullYear();
    if(dd<10){dd='0'+dd}
    if(mm<10){mm='0'+mm}                
    var datum = dd+'.'+mm+'.'+yyyy;

    if (document.getElementById('r2').checked) active_f1 = "";
    else                                       active_f1 = "X";

    if (document.getElementById('r4').checked) active_f2 = "";
    else                                       active_f2 = "X";
    
    if (document.getElementById('r6').checked) active_f3 = "";
    else                                       active_f3 = "X";

    var txtarea_nospace = $('#textarea1').val().replace(/ /g,"");
    if (txtarea_nospace == "") 
    	active_anmerkung = "";
    else                       
    	active_anmerkung = $('#textarea1').val().replace(/(?:\r\n|\r|\n)/g, ' ');

    //var dataString = "{\"betriebskontrolle\":{\"referenz\":"+active_referenz+",\"adresse\":"+active_adresse+",\"datum\":"+datum+",\"f1\":"+active_f1+",\"f2\":"+active_f2+",\"f3\":"+active_f3+",\"anmerkung\":"+active_anmerkung+"},\"location\":{\"latitude\":"+lat+",\"longitude\":"+lng+"}, \"name\":\""+config_name+"\", \"pass\":\""+config_passwort+"\"}";
    var dataString = "{\"betriebskontrolle\":{\"referenz\":\""+active_referenz+"\",\"datum\":\""+datum+"\",\"f1\":\""+active_f1+"\",\"f2\":\""+active_f2+"\",\"f3\":\""+active_f3+"\",\"anmerkung\":\""+active_anmerkung+"\"},\"location\":{\"latitude\":"+lat+",\"longitude\":"+lng+"}, \"name\":\""+config_name+"\", \"pass\":\""+config_passwort+"\"}";

    //console.log(zeit + " - We got an BG Update " + JSON.stringify(location));
    console.log("DATASTRING ---->>>> " + dataString);

    $.ajax({
        type: "POST",
        url: config_server + "/liftwerk_allinone/bk/bk_setdata.php",
        //url: "http://posttestserver.com/post.php",
        data: dataString,
        crossDomain: true,
        cache: false,
        timeout: 30000, 
        //beforeSend: function(){ $("#update").val('Connecting...');},
        success: function(data){
            console.log("DATA: " + data);
            if(data.indexOf("success") !== -1) {
                navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nBetriebskontrolle wurde gesendet!', function() {}, '');
                $( "#betriebskontrollenView" ).empty();
                $( "#betriebskontrollenView" ).hide();
                $( "#loadingView" ).hide();
                getDatabaseBK();
            }
            else if(data.indexOf("error") !== -1) {
                navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nDie BK konnte nicht abgeschlossen werden! Bitte nochmal absenden!', function() {}, '');
                $( "#loadingView" ).hide();
                $( "#betriebskontrollenView" ).show();
            }
        },
        error: function(xhr, status, error) {
            navigator.notification.alert(active_anlagenadresse.replace(/<br>/g,"\n") + '\n\nDie BK konnte nicht abgeschlossen werden! Bitte nochmal absenden!', function() {}, '');
            $( "#loadingView" ).hide();
            $( "#betriebskontrollenView" ).show();
        }
    });
    ////////////////////////////////////////////////////////////////////////
}

function distance(lat1, lon1, lat2, lon2) {
    var radlat1 = Math.PI * lat1/180;
    var radlat2 = Math.PI * lat2/180;
    var theta = lon1-lon2;
    var radtheta = Math.PI * theta/180;
    var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
    dist = Math.acos(dist);
    dist = dist * 180/Math.PI;
    dist = dist * 60 * 1.1515;
    dist = dist * 1.609344;
    active_distance = dist.toFixed(3);
}

function textAreaAdjust(o) {
    o.style.height = 'auto';
    o.style.height = (this.scrollHeight) + 'px';
}

/*
function textAreaAdjust(o) {
    o.style.height = "1px";
    o.style.height = (15+o.scrollHeight)+"px";
}
*/


