var success = true;
var manuals = [];
var $manualsDiv;
var $path;

//The directory to store data
var store;
var fileName;
var assetURL;

function openCHECKLISTEN(pfad) {
	var isTablet = (screen.width == 601) & (screen.height == 962); 
	
	store = "file:///storage/emulated/0/Liftwerk/";
		
	var pfad_splitted = pfad.split('/');
	fileName = pfad_splitted[pfad_splitted.length-1];
	assetURL = pfad;
	
	console.log(pfad_splitted);	
	console.log("checking file --> " + fileName);	
	console.log("     FROM URL --> " + assetURL);
	console.log("       TO URL --> " + store + fileName);
	console.log("    IS TABLET --> " + isTablet);
	
	$( "#loadingView" ).css('display', 'table');
    $( '#loadingStatus').text("Datei wird geladen!");
    
	window.resolveLocalFileSystemURL(store + fileName, appStartChecklist, downloadAssetChecklist);
}

function downloadAssetChecklist() {
	var fileTransfer = new FileTransfer();
	console.log("About to start transfer");
	console.log("     FROM URL --> " + assetURL);
	console.log("       TO URL --> " + store + fileName);
	
	assetURL = encodeURI(assetURL);
	
	fileTransfer.download(assetURL, store + fileName, 
		function(entry) {
			console.log("Success!");
			appStart();
		}, 
		function(err) {
			console.log("Error");
			console.log(err);
			navigator.notification.alert('Fehler beim Download!', function() {}, '');
		});
}

function getTypeChecklist(file_URI) {
    window.resolveLocalFileSystemURL(file_URI, function(fileEntry) {
        fileEntry.file(function(filee) {
        	mime = filee.type;
            //alert(filee.type); //THIS IS MIME TYPE
            
            cordova.plugins.fileOpener2.open(
			    store + fileName,
			    mime,
			    //'application/pdf', 
			    { 
			        error : function(e) { 
			            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
			            $( "#loadingView" ).hide();
			            navigator.notification.alert('Fehler beim Öffnen!', function() {}, '');
			        },
			        success : function () {
			            console.log('file opened successfully'); 
			            $( "#loadingView" ).hide();		
			        }
			    }
			);
        }, function() {
            alert('error getting MIME type');
            $( "#loadingView" ).hide();	
        });

    }, function() {
            alert('error opening file');
            $( "#loadingView" ).hide();	
        });
}

//I'm only called when the file exists or has been downloaded.
function appStartChecklist() {
	console.log("opening file --> " + store + fileName);
	
	getTypeChecklist(store + fileName);
}

function getDatabaseCHECKLISTEN(pfad) {
    //foto_state = 1;
    console.log("getDatabaseCHECKLISTEN!");   
    console.log("PFAD --> " + pfad);
    
    $( "#checklistenView" ).empty();
    $( "#checklistenView" ).hide();
    $( "#checklistenDatabaseView" ).empty();
    $( "#checklistenDatabaseView" ).hide();
    $( "#loadingView" ).css('display', 'table');
    $( '#loadingStatus').text("Datenbank wird aktualisiert!");
    var dataString = "{\"path\":\""+pfad+"\", \"pass\":\""+config_passwort+"\"}";
    $.ajax({
        type: "POST",
        url: config_server + "/liftwerk_allinone/anleitungen/anleitungen_show.php",
        data: dataString,
        crossDomain: true,
        cache: false,
        timeout: 30000,
        success: function(result){
        	checklisten = 1;
            console.log(result);
            if(result == "error")
            {
                var htmlString = '<div class="deviceContainer">' +
                                                        '<p class="deviceName">FALSCHES PASSWORT</p>' +
                                                    '</div>';
                $( "#checklistenDatabaseView" ).append( $( htmlString ) );
            }
            else
            {
	            $.each(result, function(i, field){
	                    var Name = field.Name;
	                    var Pfad = field.Path;
						var IstOrdner = field.IsDir;
						
						if(IstOrdner == "Y")
							Pfad = Pfad + '/';
						
						/*	
						if(Pfad.indexOf("../../manuals/../") !== -1)
							IstOrdner = "-";
						if(Pfad.indexOf("/./") !== -1)
							IstOrdner = "-";
							*/
						
						var pfad_splitted = Pfad.split('/');
						/*console.log(pfad_splitted);
						console.log(pfad_splitted.length);*/
						
						if(pfad_splitted[pfad_splitted.length-2] == ".")
						{
							IstOrdner = "-";
						}
						
						if(pfad_splitted[pfad_splitted.length-2] == "..")
						{
							Name = "<<<  ZURÜCK";
							Pfad = "";
							
							if(pfad_splitted[pfad_splitted.length-3] == "forms")
								IstOrdner = "-";
							else
								IstOrdner = "B";
							
							for(var i = 0; i < pfad_splitted.length - 3; i++)
							{
								Pfad += pfad_splitted[i] + "/";
							}
						}
	
	                    console.log(Name);
						console.log(Pfad);			
						console.log(IstOrdner);
												
	                    var htmlString;
	                    
	                    // Ordner 
	                    if(IstOrdner == "Y")
	                       	htmlString = '<div class="deviceContainer" onclick="getDatabaseCHECKLISTEN(\'' + Pfad + '\')">' +
	                                                        '<p class="deviceName">' + Name + '</p>' +
	                                                    '</div>';
	                    // Zurück Button
	                    else if(IstOrdner == "B")
	                       	htmlString = '<div class="deviceContainer2" onclick="getDatabaseCHECKLISTEN(\'' + Pfad + '\')">' +
	                                                        '<p class="deviceName">' + Name + '</p>' +
	                                                    '</div>';
	                    // Datei
	                    else if(IstOrdner == "N")
	                    	htmlString = '<div class="deviceContainer1" onclick="openCHECKLISTEN(\'' + Pfad.replace("../..", config_server) + '\')">' +
	                                                        '<p class="deviceName">' + Name + '</p>' +
	                                                    '</div>';
	                    
	                    $( "#checklistenDatabaseView" ).append( $( htmlString ) );
	                });
            }
            $( "#loadingView" ).hide();
            $( "#checklistenDatabaseView" ).show();
        },
        error: function(result) {
            navigator.notification.alert('Keine Verbindung zum Server!', function() {}, '');
            console.log(result);
            $( "#loadingView" ).hide();
            $( "#welcomeView" ).show();
        }
    });
}
