function getCalendarweek(d) { 
    // Create a copy of this date object  
    var source  = new Date(d);  
    var target  = new Date(d);  
    
    // ISO week date weeks start on monday  
    // so correct the day number  
    var dayNr   = (source.getDay() + 6) % 7;  

    // Set the target to the thursday of this week so the  
    // target date is in the right year  
    target.setDate(target.getDate() - dayNr + 3);  

    // ISO 8601 states that week 1 is the week  
    // with january 4th in it  
    var jan4    = new Date(target.getFullYear(), 0, 4);  

    // Number of days between target date and january 4th  
    var dayDiff = (target - jan4) / 86400000;    

        if(new Date(target.getFullYear(), 0, 1).getDay() < 5) {
        // Calculate week number: Week 1 (january 4th) plus the    
        // number of weeks between target date and january 4th    
        return 1 + Math.ceil(dayDiff / 7);    
    }
    else {  // jan 4th is on the next week (so next week is week 1)
        return Math.ceil(dayDiff / 7); 
    }   
}

// input = "26.04.2017T10:07:20"
function strToDate(input) {
    input = input + "T12:00:00";
    var dateStr = input.substring(0, 10);
    var dateParts = dateStr.split('.');
    var timeStr = input.substring(11, 19);
    var timeParts = timeStr.split(':');
    var result = new Date(Date.UTC(dateParts[2], dateParts[1]-1,
        dateParts[0], timeParts[0], timeParts[1], timeParts[2]));
    return result;
}

function getQuarter(d) {
  d = d || new Date();
  var m = Math.floor((d.getMonth()+3)/3);
  return m;
}

function Navigation()
{
    var nav_adresse;
    var nav_adresse_temp;
    console.log('Active Adresse: ' + active_adresse);
    
    if(active_adresse.indexOf('<br>') !== -1)
        nav_adresse_temp = active_adresse.split('<br>')[1];
    else
        nav_adresse_temp = active_adresse;

    nav_adresse_temp = nav_adresse_temp.replace("ALT","").replace("NEU","");

    console.log('Nav Adresse Temp: ' + nav_adresse_temp);
    
    if(nav_adresse_temp.indexOf('/') !== -1)
        nav_adresse = nav_adresse_temp.split('/')[0] + ', ' + nav_adresse_temp.split(',')[1];
    else
        nav_adresse = nav_adresse_temp;

    console.log('Nav Adresse: ' + nav_adresse);
        
    launchnavigator.navigate(nav_adresse);
}
